@echo off

setlocal ENABLEDELAYEDEXPANSION
set basedir=%cd%

set user=tipadmin
set passwd=tippass
if not "%1" == "" (
	set user=%1
)
if not "%2" == "" (
	set passwd=%2
)

echo Searching for installed components...

pushd "%SI_PATH%\bin" 2>nul
if ERRORLEVEL 1 (
	pushd "%USERPROFILE%\acsi_%USERNAME%" 2>nul
	if ERRORLEVEL 1 (
		pushd "%PROGRAMFILES(x86)%\IBM\Common\acsi\bin" 2>nul
		if ERRORLEVEL 1 (
			pushd "%PROGRAMFILES%\IBM\Common\acsi\bin"
			if ERRORLEVEL 1 (
				echo Unable to find DE
				exit /b 1
			)
		)
	)
)
call ..\setenv.cmd
set patched=0
for /f "delims=, tokens=2,4,5,6" %%i in ('de_lsrootiu.cmd ^| find "IU,TUAM_" ^| sort') do (
    set ver=%%j
	if "!ver:~0,5!" == "7.3.0" (
	  if "!ver:~6,2!" lss "3" (
		if exist "%basedir%\%%i\META-INF\." (
			echo Applying patch for %%i
			pushd "%basedir%\%%i\META-INF"
			if "%%i" == "TUAM_UI" (
				call "%%k\bin\setupEnv"
			    set uid=%%l
				echo Variable#RootIUTypeID[!uid:~0,32!,7.3.0.3]#IAGLOBAL_TIP_HOME=!TIP_HOME:\=\\!> var.properties
				echo Variable#RootIUTypeID[!uid:~0,32!,7.3.0.3]#shExt=bat>> var.properties
				echo Variable#RootIUTypeID[!uid:~0,32!,7.3.0.3]#IAGLOBAL_WASUserID=%user%>> var.properties
				echo Variable#RootIUTypeID[!uid:~0,32!,7.3.0.3]#IALOCAL_WASPassword=%passwd%>> var.properties
				call manageIU.bat -o update -u true  -i var.properties -r "!TUAM_HOME!" -p packagedIU.xml 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
				set status=!ERRORLEVEL!
				del /q var.properties
			) else (
				set TUAM_HOME=%%k
				call manageIU.bat -o update -r "!TUAM_HOME!" -p packagedIU.xml -u true 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
				set status=!ERRORLEVEL!
			)
			if not !status! == 0 (
				echo Patch failed
				exit /b 1
			)
			mkdir "!TUAM_HOME!\_uninst\fixes\fp3\%%i" 2>nul
			copy * "!TUAM_HOME!\_uninst\fixes\fp3\%%i" >nul
			popd
			set /a patched+=1
		)
	  )
	)
)

popd
if %patched% == 0 (
   echo TUAM Release 7.3.0.0 to 7.3.0.2 must be installed to install this fix pack.
   echo Please install this version before attempting to install this fix pack.
   echo Fix has not been applied successfully.
   exit /b 1
)

endlocal

