@echo off

setlocal ENABLEDELAYEDEXPANSION
set basedir=%cd%

set user=tipadmin
set passwd=tippass
if not "%1" == "" (
	set user=%1
)
if not "%2" == "" (
	set passwd=%2
)

echo Searching for installed components...

pushd "%SI_PATH%\bin" 2>nul
if ERRORLEVEL 1 (
	pushd "%USERPROFILE%\acsi_%USERNAME%" 2>nul
	if ERRORLEVEL 1 (
		pushd "%PROGRAMFILES(x86)%\IBM\Common\acsi\bin" 2>nul
		if ERRORLEVEL 1 (
			pushd "%PROGRAMFILES%\IBM\Common\acsi\bin"
			if ERRORLEVEL 1 (
				echo Unable to find DE
				exit /b 1
			)
		)
	)
)
call ..\setenv.cmd
set patched=0
for /f "delims=, tokens=2,4,5,6" %%i in ('de_lsrootiu.cmd ^| find "IU,TUAM_" ^| sort') do (
	if "%%j" == "7.3.0.3" (
		set TUAM_HOME=%%k
		if exist "!TUAM_HOME!\_uninst\fixes\fp3\%%i\." (
			echo Undoing patch for %%i
			pushd "!TUAM_HOME!\_uninst\fixes\fp3\%%i"
			if "%%i" == "TUAM_UI" (
				call %%k\bin\setupEnv
			    set uid=%%l
				rem As the non-fixpack deploy script doesn't have the path space fix, we want to keep the
				rem fixpack one around until we have redeployed the original 7.3.0.1 war.
				copy /y "!TUAM_HOME!\setup\console\deployTuam.bat" "!TUAM_HOME!\setup\console\deployTuam_fp2.bat" 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
				copy /y "!TUAM_HOME!\setup\console\deployTUAMConsole.py" "!TUAM_HOME!\setup\console\deployTUAMConsole_fp2.py" 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
				echo Variable#RootIUTypeID[!uid:~0,32!,7.3.0.3]#IAGLOBAL_TIP_HOME=!TIP_HOME:\=\\!> var.properties
				echo Variable#RootIUTypeID[!uid:~0,32!,7.3.0.3]#shExt=bat>> var.properties
				call manageIU.bat -o undo -i var.properties -r "!TUAM_HOME!" -p packagedIU.xml 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
				set status=!ERRORLEVEL!
				del /q var.properties
				if !status! == 0 (
					move /y "!TUAM_HOME!\setup\console\deployTUAMConsole.py" "!TUAM_HOME!\setup\console\deployTUAMConsole_fp0.py" 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
					move /y "!TUAM_HOME!\setup\console\deployTUAMConsole_fp2.py" "!TUAM_HOME!\setup\console\deployTUAMConsole.py" 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
					call "!TUAM_HOME!\setup\console\deployTuam_fp2.bat" replace %user% %passwd% 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
					set status=!ERRORLEVEL!
					del /q "!TUAM_HOME!\setup\console\deployTuam_fp2.bat" 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
					move /y "!TUAM_HOME!\setup\console\deployTUAMConsole_fp0.py" "!TUAM_HOME!\setup\console\deployTUAMConsole.py" 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
				) else (
					del /q "!TUAM_HOME!\setup\console\deployTUAMConsole_fp2.py" 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
				)
				del /q "!TUAM_HOME!\setup\console\deployTuam_fp2.bat" 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
			) else (
				call manageIU.bat -o undo -r "!TUAM_HOME!" -p packagedIU.xml 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
				set status=!ERRORLEVEL!
			)
			if not !status! == 0 (
				echo Undo failed
				exit /b 1
			) else (
				del /q /s "!TUAM_HOME!\_uninst\fixes\fp3\%%i" 1>>!TUAM_HOME!\logs\fp_%%i.log 2>&1
			)
			popd
			set /a patched+=1
		)
	)
)

popd
if %patched% == 0 (
   echo TUAM Release 7.3.0.3 must be installed to remove this fix pack.
   echo Please install this version before attempting to remove this fix pack.
   echo Fix has not been unapplied successfully.
   exit /b 1
)

endlocal

